image: $CI_REGISTRY_IMAGE:aio

variables:
  CI_REGISTRY_IMAGE: $CI_REGISTRY/$CI_PROJECT_PATH

stages:
  - init
  - commit_tests
  - build
  - acceptance_tests
  - deploy

cache:
  paths:
  - node_modules/
  - $HOME/.yarn-cache/

runner_aio:
  stage: init
  image: docker:latest
  services:
    - docker:dind
  variables:
    IMAGE_PATH: "cicd/runners/aio"
  script: |
    docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY_IMAGE
    docker build -t $CI_REGISTRY_IMAGE:$(basename $IMAGE_PATH) $IMAGE_PATH
    docker push $CI_REGISTRY_IMAGE:$(basename $IMAGE_PATH)
  when: manual

deps:
  stage: init
  script: |
    ./cicd/scripts/print_tool_versions.sh
    npm install

  artifacts:
    expire_in: 1 week
    paths:
      - node_modules/
      - $HOME/.yarn-cache/

unit:
  stage: commit_tests
  image: $CI_REGISTRY_IMAGE:aio
  script: |
    npm install
    npm run test:unit
  artifacts:
    expire_in: 2 weeks
    paths:
      - coverage

lint:
  stage: commit_tests
  script: |
    npm install
    npm run lint

pkg_review:
  stage: build
  script:
    yarn outdated & npm outdated || exit 0
    yarn licenses ls
    yarn licenses generateDisclaimer
  when: manual

pkg_build:
  stage: build
  script: |
    npm install
    npm build
    npm install --production
    npm publish --tag next
  only:
    - master





# integration:
#   stage: acceptance_tests
#   script: yarn run tests:integration
#   artifacts:
#     expire_in: 2 weeks
#     paths:
#     - coverage

# api:
#   stage: acceptance_tests
#   script: newman
#   artifacts:
#     expire_in: 2 weeks
#     paths:
#     - coverage

# load:
#   stage: acceptance_tests
#   script: http://gettaurus.org/

# # needs $CODECLIMATE_REPO_TOKEN
# report:
#   stage: deploy
#   script:
#   - merge-lcov coverage merged-lcov.info && codeclimate-test-reporter  < merged-lcov.info
